diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 15f80f785..56f029b0d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -3,12 +3,12 @@ package net.minecraft.core.entity;
 import com.b100.utils.StringUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.Global;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.player.Player;
@@ -22,25 +22,26 @@ import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.ArrayList;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
-public abstract class Mob extends Entity
-{
+public abstract class Mob extends Entity {
     public static boolean SPAWN_NO_AI = false;
     public static final int DATA_VARIANT = 1;
     public static final int DATA_HEALTH = 2;
     protected @NotNull Map<ItemFood, ConsumedFood> consumedFood = new HashMap<>();
     public int heartsHalvesLife;
-//    public float timeOffs;
+    //    public float timeOffs;
 //    public float rotA;
     public float yBodyRot;
     public float yBodyRotO;
@@ -48,7 +49,7 @@ public abstract class Mob extends Entity
     protected float prevRidingRotUnused;
     protected float unusedRotation1;
     protected float prevRotationUnused;
-//    protected boolean hasHair;
+    //    protected boolean hasHair;
 //    protected boolean allowAlpha;
 //    protected float rotOffs;
 //    protected float bobStrength;
@@ -81,7 +82,7 @@ public abstract class Mob extends Entity
     protected double newPosZ;
     protected double newRotationYaw;
     protected double newRotationPitch;
-//    float fallTime;
+    //    float fallTime;
     protected int lastDamage;
     protected int entityAge;
     protected float moveStrafing;
@@ -111,50 +112,49 @@ public abstract class Mob extends Entity
     public @NotNull PlacementMode placementModeOverride = PlacementMode.FACING;
     public final @NotNull List<WeightedRandomLootObject> mobDrops = new ArrayList<>();
 
-    public Mob(@NotNull final World world)
-    {
+    public Mob(@NotNull final World world) {
         super(world);
-        heartsHalvesLife = 20;
-        yBodyRot = 0.0F;
-        yBodyRotO = 0.0F;
+        this.heartsHalvesLife = 20;
+        this.yBodyRot = 0.0F;
+        this.yBodyRotO = 0.0F;
 //        hasHair = true;
 //        allowAlpha = true;
 //        rotOffs = 0.0F;
 //        bobStrength = 1.0F;
-        scoreValue = 0;
+        this.scoreValue = 0;
 //        renderOffset = 0.0F;
-        isMultiplayerEntity = false;
-        attackedAtYaw = 0.0F;
-        deathTime = 0;
-        attackTime = 0;
-        dead = false;
+        this.isMultiplayerEntity = false;
+        this.attackedAtYaw = 0.0F;
+        this.deathTime = 0;
+        this.attackTime = 0;
+        this.dead = false;
 //        modelNum = -1;
 //        animSpeed = (float)(Math.random() * 0.9D + 0.1D);
 //        fallTime = 0.0F;
-        lastDamage = 0;
-        entityAge = 0;
-        isJumping = false;
-        defaultPitch = 0.0F;
-        moveSpeed = 0.7F;
-        numTicksToChaseTarget = 0;
-        blocksBuilding = true;
+        this.lastDamage = 0;
+        this.entityAge = 0;
+        this.isJumping = false;
+        this.defaultPitch = 0.0F;
+        this.moveSpeed = 0.7F;
+        this.numTicksToChaseTarget = 0;
+        this.blocksBuilding = true;
 //        rotA = (float)(Math.random() + 1.0D) * 0.01F;
-        setPos(x, y, z);
+        setPos(this.x, this.y, this.z);
 //        timeOffs = (float) Math.random() * 12398F;
-        yRot = (float)(Math.random() * Math.PI * 2D);
-        footSize = 0.5F;
+        this.yRot = (float) (Math.random() * Math.PI * 2D);
+        this.footSize = 0.5F;
 
-        int variant = random.nextInt(0xFF);
-        entityData.define(DATA_VARIANT, (byte) variant, Byte.class);
-        entityData.define(DATA_HEALTH, getMaxHealth(), Integer.class);
+        int variant = this.random.nextInt(0xFF);
+        this.entityData.define(DATA_VARIANT, (byte) variant, Byte.class);
+        this.entityData.define(DATA_HEALTH, getMaxHealth(), Integer.class);
         setSkinVariant(variant);
 
-        speed = 0.1f;
-        flySpeed = 0.02f;
+        this.speed = 0.1f;
+        this.flySpeed = 0.02f;
         this.noAI = SPAWN_NO_AI;
     }
 
-    protected final void setTextureIdentifier(final  @NotNull String namespace, final @NotNull String id) {
+    protected final void setTextureIdentifier(final @NotNull String namespace, final @NotNull String id) {
         this.textureIdentifier = NamespaceID.getPermanent(namespace, id);
         this.basePath = String.format("/assets/%s/textures/entity/%s/", this.textureIdentifier.namespace(), this.textureIdentifier.value());
         this.defaultTexture = this.basePath + "0.png";
@@ -162,17 +162,15 @@ public abstract class Mob extends Entity
     }
 
     @Override
-	protected void defineSynchedData()
-    {
+    protected void defineSynchedData() {
     }
 
-    public boolean canEntityBeSeen(Entity entity)
-    {
-        return world.checkBlockCollisionBetweenPoints(Vec3.fromPool(x, y + (double) getHeadHeight(), z), Vec3.fromPool(entity.x, entity.y + (double)entity.getHeadHeight(), entity.z)) == null;
+    public boolean canEntityBeSeen(Entity entity) {
+        return this.world.checkBlockCollisionBetweenPoints(new Vector3d(this.x, this.y + (double) getHeadHeight(), this.z), new Vector3d(entity.x, entity.y + (double) entity.getHeadHeight(), entity.z)) == null;
     }
 
     @Override
-	public @NotNull String getEntityTexture() {
+    public @NotNull String getEntityTexture() {
         return this.basePath + getTextureReference() + ".png";
     }
 
@@ -200,43 +198,38 @@ public abstract class Mob extends Entity
     }
 
     @Override
-	public boolean isPickable()
-    {
-        return !removed;
+    public boolean isPickable() {
+        return !this.removed;
     }
 
     @Override
-	public boolean isPushable()
-    {
-        return !removed;
+    public boolean isPushable() {
+        return !this.removed;
     }
 
-    public boolean isJumping() { return isJumping; }
+    public boolean isJumping() {
+        return this.isJumping;
+    }
 
     @Override
-	public float getHeadHeight()
-    {
-        return bbHeight * 0.85F;
+    public float getHeadHeight() {
+        return this.bbHeight * 0.85F;
     }
 
-    public int getAmbientSoundInterval()
-    {
+    public int getAmbientSoundInterval() {
         return 80;
     }
 
-    public @NotNull String getDisplayName()
-    {
-        return TextFormatting.get(chatColor) + nickname;
+    public @NotNull String getDisplayName() {
+        return TextFormatting.get(this.chatColor) + this.nickname;
     }
 
     @Override
-    public boolean interact(@NotNull Player player)
-    {
+    public boolean interact(@NotNull Player player) {
         ItemStack item = player.inventory.getCurrentItem();
-        if (item != null && item.itemID == Items.LABEL.id && item.hasCustomName())
-        {
-            if(item.hasCustomColor()) {
-            	this.chatColor = item.getCustomColor();
+        if (item != null && item.itemID == Items.LABEL.id && item.hasCustomName()) {
+            if (item.hasCustomColor()) {
+                this.chatColor = item.getCustomColor();
             } else {
                 this.chatColor = 0;
             }
@@ -247,13 +240,12 @@ public abstract class Mob extends Entity
         return false;
     }
 
-    protected void onLabelled()
-    {
+    protected void onLabelled() {
     }
 
-    public void setNickname(@NotNull String nickname){
+    public void setNickname(@NotNull String nickname) {
         this.nickname = nickname;
-        hadNicknameSet = true;
+        this.hadNicknameSet = true;
         onLabelled();
     }
 
@@ -266,237 +258,217 @@ public abstract class Mob extends Entity
         }
     }
 
-    public void playLivingSound()
-    {
+    public void playLivingSound() {
         String s = getLivingSound();
-        if(s != null && !world.isClientSide)
-        {
-            world.playSoundAtEntity(null, this, s, getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
+        if (s != null && !this.world.isClientSide) {
+            this.world.playSoundAtEntity(null, this, s, getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
         }
     }
-    
-    public void playHurtSound()
-    {
-        world.playSoundAtEntity(null, this, getHurtSound(), getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
+
+    public void playHurtSound() {
+        this.world.playSoundAtEntity(null, this, getHurtSound(), getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
     }
-    
-    public void playDeathSound()
-    {
-        world.playSoundAtEntity(null, this, getDeathSound(), getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
+
+    public void playDeathSound() {
+        this.world.playSoundAtEntity(null, this, getDeathSound(), getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
     }
 
     @Override
-	public void baseTick()
-    {
-        prevSwingProgress = swingProgress;
+    public void baseTick() {
+        this.prevSwingProgress = this.swingProgress;
         super.baseTick();
-        if(random.nextInt(1000) < livingSoundTime++)
-        {
-            livingSoundTime = -getAmbientSoundInterval();
+        if (this.random.nextInt(1000) < this.livingSoundTime++) {
+            this.livingSoundTime = -getAmbientSoundInterval();
             playLivingSound();
         }
-        if(isAlive() && isInWall() && !noPhysics)
-        {
+        if (isAlive() && isInWall() && !this.noPhysics) {
             hurt(null, 1, null);
         }
-        if(fireImmune || world.isClientSide)
-        {
-            remainingFireTicks = 0;
+        if (this.fireImmune || this.world.isClientSide) {
+            this.remainingFireTicks = 0;
         }
         trySuffocate();
-        prevCameraPitch = cameraPitch;
-        if(attackTime > 0)
-        {
-            attackTime--;
-        }
-        if(hurtTime > 0)
-        {
-            hurtTime--;
-        }
-        if(heartsFlashTime > 0)
-        {
-            heartsFlashTime--;
-        }
-        if(getHealth() <= 0)
-        {
-            deathTime++;
-            if(deathTime > 20)
-            {
+        this.prevCameraPitch = this.cameraPitch;
+        if (this.attackTime > 0) {
+            this.attackTime--;
+        }
+        if (this.hurtTime > 0) {
+            this.hurtTime--;
+        }
+        if (this.heartsFlashTime > 0) {
+            this.heartsFlashTime--;
+        }
+        if (getHealth() <= 0) {
+            this.deathTime++;
+            if (this.deathTime > 20) {
                 beforeRemove();
                 remove();
-                for(int j = 0; j < 20; j++)
-                {
-                    double motionX = random.nextGaussian() * 0.02D;
-                    double motionY = random.nextGaussian() * 0.02D;
-                    double motionZ = random.nextGaussian() * 0.02D;
-                    world.spawnParticle("explode", (x + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth, y + (double)(random.nextFloat() * bbHeight), (z + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth, motionX, motionY, motionZ, 0);
+                for (int j = 0; j < 20; j++) {
+                    double motionX = this.random.nextGaussian() * 0.02D;
+                    double motionY = this.random.nextGaussian() * 0.02D;
+                    double motionZ = this.random.nextGaussian() * 0.02D;
+                    this.world.spawnParticle("explode", (this.x + (double) (this.random.nextFloat() * this.bbWidth * 2.0F)) - (double) this.bbWidth, this.y + (double) (this.random.nextFloat() * this.bbHeight), (this.z + (double) (this.random.nextFloat() * this.bbWidth * 2.0F)) - (double) this.bbWidth, motionX, motionY, motionZ, 0);
                 }
 
             }
         }
         List<ItemFood> finishedFood = new ArrayList<>();
-        for (Map.Entry<ItemFood, ConsumedFood> entry : consumedFood.entrySet()) {
+        for (Map.Entry<ItemFood, ConsumedFood> entry : this.consumedFood.entrySet()) {
             entry.getValue().tick();
             if (entry.getValue().isFinished()) {
                 finishedFood.add(entry.getKey());
             }
         }
         for (ItemFood food : finishedFood) {
-            consumedFood.remove(food);
-        }
-        prevRotationUnused = unusedRotation1;
-        yBodyRotO = yBodyRot;
-        yRotO = yRot;
-        xRotO = xRot;
-    }
-
-    public void trySuffocate(){
-        if(isAlive() && isUnderLiquid(Material.water) && !canBreatheUnderwater())
-        {
-            airSupply--;
-            if(airSupply == -20)
-            {
-                airSupply = 0;
-                for(int i = 0; i < 8; i++)
-                {
-                    double offX = random.nextFloat() - random.nextFloat();
-                    double offY = random.nextFloat() - random.nextFloat();
-                    double offZ = random.nextFloat() - random.nextFloat();
-                    world.spawnParticle("bubble", x + offX, y + offY, z + offZ, xd, yd, zd, 0);
+            this.consumedFood.remove(food);
+        }
+        this.prevRotationUnused = this.unusedRotation1;
+        this.yBodyRotO = this.yBodyRot;
+        this.yRotO = this.yRot;
+        this.xRotO = this.xRot;
+    }
+
+    public void trySuffocate() {
+        if (isAlive() && isUnderLiquid(Materials.WATER) && !canBreatheUnderwater()) {
+            this.airSupply--;
+            if (this.airSupply == -20) {
+                this.airSupply = 0;
+                for (int i = 0; i < 8; i++) {
+                    double offX = this.random.nextFloat() - this.random.nextFloat();
+                    double offY = this.random.nextFloat() - this.random.nextFloat();
+                    double offZ = this.random.nextFloat() - this.random.nextFloat();
+                    this.world.spawnParticle("bubble", this.x + offX, this.y + offY, this.z + offZ, this.xd, this.yd, this.zd, 0);
                 }
 
                 hurt(null, 2, DamageType.DROWN);
             }
-            remainingFireTicks = 0;
-        } else
-        {
-            airSupply = airMaxSupply;
+            this.remainingFireTicks = 0;
+        } else {
+            this.airSupply = this.airMaxSupply;
         }
     }
 
-    public void spawnExplosionParticle()
-    {
-        for(int i = 0; i < 20; i++)
-        {
-            double d = random.nextGaussian() * 0.02D;
-            double d1 = random.nextGaussian() * 0.02D;
-            double d2 = random.nextGaussian() * 0.02D;
+    public void spawnExplosionParticle() {
+        for (int i = 0; i < 20; i++) {
+            double d = this.random.nextGaussian() * 0.02D;
+            double d1 = this.random.nextGaussian() * 0.02D;
+            double d2 = this.random.nextGaussian() * 0.02D;
             double d3 = 10D;
-            world.spawnParticle("explode", (x + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth - d * d3, (y + (double)(random.nextFloat() * bbHeight)) - d1 * d3, (z + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth - d2 * d3, d, d1, d2, 0);
+            this.world.spawnParticle("explode", (this.x + (double) (this.random.nextFloat() * this.bbWidth * 2.0F)) - (double) this.bbWidth - d * d3, (this.y + (double) (this.random.nextFloat() * this.bbHeight)) - d1 * d3, (this.z + (double) (this.random.nextFloat() * this.bbWidth * 2.0F)) - (double) this.bbWidth - d2 * d3, d, d1, d2, 0);
         }
 
     }
 
     @Override
-	public void rideTick()
-    {
+    public void rideTick() {
         super.rideTick();
-        ridingRotUnused = prevRidingRotUnused;
-        prevRidingRotUnused = 0.0F;
+        this.ridingRotUnused = this.prevRidingRotUnused;
+        this.prevRidingRotUnused = 0.0F;
     }
 
     @Override
-	public void lerpTo(double x, double y, double z, float yRot,
-                       float xRot, int i)
-    {
-        heightOffset = 0.0F;
-        newPosX = x;
-        newPosY = y;
-        newPosZ = z;
-        newRotationYaw = yRot;
-        newRotationPitch = xRot;
-        newPosRotationIncrements = i;
+    public void lerpTo(double x, double y, double z, float yRot,
+                       float xRot, int i) {
+        this.heightOffset = 0.0F;
+        this.newPosX = x;
+        this.newPosY = y;
+        this.newPosZ = z;
+        this.newRotationYaw = yRot;
+        this.newRotationPitch = xRot;
+        this.newPosRotationIncrements = i;
     }
 
     @Override
-	public void tick()
-    {
+    public void tick() {
         super.tick();
         if (this.noAI) return;
         onLivingUpdate();
-        double d = x - xo;
-        double d1 = z - zo;
+        double d = this.x - this.xo;
+        double d1 = this.z - this.zo;
         float f = MathHelper.sqrt(d * d + d1 * d1);
-        float f1 = yBodyRot;
+        float f1 = this.yBodyRot;
         float f2 = 0.0F;
-        ridingRotUnused = prevRidingRotUnused;
+        this.ridingRotUnused = this.prevRidingRotUnused;
         float f3 = 0.0F;
-        if(f > 0.05F)
-        {
+        if (f > 0.05F) {
             f3 = 1.0F;
             f2 = f * 3F;
             f1 = ((float) java.lang.Math.atan2(d1, d) * 180F) / MathHelper.PI - 90F;
         }
-        if(swingProgress > 0.0F)
-        {
-            f1 = yRot;
+        if (this.swingProgress > 0.0F) {
+            f1 = this.yRot;
         }
-        if(!onGround)
-        {
+        if (!this.onGround) {
             f3 = 0.0F;
         }
-        prevRidingRotUnused = prevRidingRotUnused + (f3 - prevRidingRotUnused) * 0.3F;
+        this.prevRidingRotUnused = this.prevRidingRotUnused + (f3 - this.prevRidingRotUnused) * 0.3F;
         float f4;
-        for(f4 = f1 - yBodyRot; f4 < -180F; f4 += 360F) { }
-        for(; f4 >= 180F; f4 -= 360F) { }
-        yBodyRot += f4 * 0.3F;
+        for (f4 = f1 - this.yBodyRot; f4 < -180F; f4 += 360F) {
+        }
+        for (; f4 >= 180F; f4 -= 360F) {
+        }
+        this.yBodyRot += f4 * 0.3F;
         float f5;
-        for(f5 = yRot - yBodyRot; f5 < -180F; f5 += 360F) { }
-        for(; f5 >= 180F; f5 -= 360F) { }
+        for (f5 = this.yRot - this.yBodyRot; f5 < -180F; f5 += 360F) {
+        }
+        for (; f5 >= 180F; f5 -= 360F) {
+        }
         boolean flag = f5 < -90F || f5 >= 90F;
-        if(f5 < -75F)
-        {
+        if (f5 < -75F) {
             f5 = -75F;
         }
-        if(f5 >= 75F)
-        {
+        if (f5 >= 75F) {
             f5 = 75F;
         }
-        yBodyRot = yRot - f5;
-        if(f5 * f5 > 2500F)
-        {
-            yBodyRot += f5 * 0.2F;
+        this.yBodyRot = this.yRot - f5;
+        if (f5 * f5 > 2500F) {
+            this.yBodyRot += f5 * 0.2F;
         }
-        if(flag)
-        {
+        if (flag) {
             f2 *= -1F;
         }
-        for(; yRot - yRotO < -180F; yRotO -= 360F) { }
-        for(; yRot - yRotO >= 180F; yRotO += 360F) { }
-        for(; yBodyRot - yBodyRotO < -180F; yBodyRotO -= 360F) { }
-        for(; yBodyRot - yBodyRotO >= 180F; yBodyRotO += 360F) { }
-        for(; xRot - xRotO < -180F; xRotO -= 360F) { }
-        for(; xRot - xRotO >= 180F; xRotO += 360F) { }
-        unusedRotation1 += f2;
+        for (; this.yRot - this.yRotO < -180F; this.yRotO -= 360F) {
+        }
+        for (; this.yRot - this.yRotO >= 180F; this.yRotO += 360F) {
+        }
+        for (; this.yBodyRot - this.yBodyRotO < -180F; this.yBodyRotO -= 360F) {
+        }
+        for (; this.yBodyRot - this.yBodyRotO >= 180F; this.yBodyRotO += 360F) {
+        }
+        for (; this.xRot - this.xRotO < -180F; this.xRotO -= 360F) {
+        }
+        for (; this.xRot - this.xRotO >= 180F; this.xRotO += 360F) {
+        }
+        this.unusedRotation1 += f2;
     }
 
-    public void heal(int i)
-    {
-        if(getHealth() <= 0)
-        {
+    public void heal(int i) {
+        if (getHealth() <= 0) {
             return;
         }
         setHealthRaw(getHealth() + i);
-        if(getHealth() > getMaxHealth())
-        {
+        if (getHealth() > getMaxHealth()) {
             setHealthRaw(getMaxHealth());
         }
-        heartsFlashTime = heartsHalvesLife / 2;
+        this.heartsFlashTime = this.heartsHalvesLife / 2;
     }
-    public int getHealth(){
-        return entityData.getInt(DATA_HEALTH);
+
+    public int getHealth() {
+        return this.entityData.getInt(DATA_HEALTH);
     }
-    public void setHealthRaw(int health){
-        entityData.set(DATA_HEALTH, health);
+
+    public void setHealthRaw(int health) {
+        this.entityData.set(DATA_HEALTH, health);
     }
-    public int getMaxHealth(){
+
+    public int getMaxHealth() {
         return 10;
     }
 
-    public int getTotalHealingRemaining(){
+    public int getTotalHealingRemaining() {
         int totalHealingRemaining = 0;
         for (ConsumedFood value :
-             consumedFood.values()) {
+            this.consumedFood.values()) {
             totalHealingRemaining += value.getHealRemaining();
         }
         return totalHealingRemaining;
